# -*- coding: utf-8 -*-
import gtk, pango, gobject
import os

import WIDGET, child, GConf, Conf, func, i18n

_ = i18n.gettext()

class ExternalCommand (WIDGET.WIDGET) :

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE = None
	STATE = None
	CALLBACK_FUNCTIONS = dict()

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("completion_liststore") :
			raise ValueError, _("completion_liststore must be included.")
		else :
			self.LISTSTORE = kwargs["completion_liststore"]

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_ok"	: self.on_ok, \
			"on_run"	: self.on_run, \
		}

		WIDGET.WIDGET.__init__( \
			self, "external_command", None, handler)

		self.WIDGET_SELF.set_title(_("Run Command"))

		__label = self.xml.get_widget("label92")
		__label.set_label(_("Run Command"))

		self.ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("entry17")
		__completion = gtk.EntryCompletion()
		self.ENTRY_EXTERNAL_COMMAND.set_completion(__completion)
		__completion.set_model(self.LISTSTORE)
		__completion.set_text_column(0)

	def on_ok (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE.append([__c, ])
		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("external_command", external_command=__c.strip())

		self.on_close(widget)

	def on_run (self, widget) :
		self.on_ok(widget)

class AskCloseAllTabDialog (WIDGET.WIDGET) :

	GCONF_CLIENT = None
	LIST_TAB = list()
	NOTEBOOK = None
	STATE = None

	def __init__ (self, ROOT, state) :
		handler = { \
			"on_ok"	: self.on_ok, \
			"on_cancel" : self.on_close, \
		}

		WIDGET.WIDGET.__init__( \
			self, "quit", ROOT, handler)

		self.WIDGET_SELF.set_title(_("Quit"))

		self.STATE = state

		if self.STATE.DATA.has_key("tab-list") :
			self.LIST_TAB = self.STATE.DATA["tab-list"]

		if self.STATE.DATA.has_key("notebook") :
			self.NOTEBOOK = self.STATE.DATA["notebook"]

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		__label = self.xml.get_widget("label87")
		__label.set_label( \
_("Quit VEE.\nAll the opened tab will be closed."))

	def on_ok (self, widget) :
		self.rememberGememetry()
		#self.removeAllTab()

		gtk.main_quit()

		return True

	def rememberGememetry (self) :
		# save the latest window geometry.
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(x, y) = self.WIDGET_ROOT.get_position()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (__wh0[0], __wh0[1], x, y) \
		)

	def removeAllTab (self) :
		ALL_REMOVED = True

		# try to close all the tab.
		_n = self.NOTEBOOK.get_n_pages() - 1
		for i in range(_n) :
			try :
				ch = self.LIST_TAB[i]
			except :
				break

			try :
				exit_method = getattr(ch.Child, "exit")
			except AttributeError :
				pass
			else :
				ch.Child.exit()

				if not ch.Child.IS_REMOVED :
					ALL_REMOVED = False
					break

		if ALL_REMOVED : print "all removed"
		#gtk.main_quit()

class NoValidCommand (WIDGET.WIDGET) :

	def __init__ (self, command=str()) :
		WIDGET.WIDGET.__init__(self, "error")

		self.WIDGET_SELF.set_title(_("This command does not exist. Check it out."))

		if command.strip() :
			__label = self.xml.get_widget("label90")
			__label.set_label( \
				_("\n'%s' does not exist. Check it.\n\n") % command \
			)

class FontSelectionDialog (WIDGET.WIDGET) :

	def __init__ (self, ROOT, TAB) :
		handler = { \
			"on_ok"	: self.on_ok,
			"on_cancel" : self.on_close,
			"on_apply" : self.on_apply,
		}

		WIDGET.WIDGET.__init__( \
			self, "fontselectiondialog1", ROOT, handler)

		self.TAB = TAB
		self.WIDGET_SELF.set_font_name(self.TAB.VTE.VTE.get_font().to_string())

	def on_apply (self, widget) :
		self.setFont()

	def on_ok (self, widget) :
		self.setFont()
		self.on_close(widget)

	def setFont (self) :
		pd = pango.FontDescription(self.WIDGET_SELF.get_font_name())
		self.TAB.VTE.VTE.set_font(pd)

class FileSelectionDialog (WIDGET.WIDGET) :

	comboSetChild = "vim"
	CALLBACK_FUNCTIONS = dict()
	STATE = None

	CHILD_VIM = 0
	CHILD_GVIM = 1

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_open"	: self.on_open, \
			"on_cancel" : self.on_close, \
		}

		WIDGET.WIDGET.__init__( \
			self, "filechooserdialog2", None, handler)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		# get the directory path, which was opened latest. 
		__path = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["last-directory-path-in-fileselectdialog"]["key"])
		if not __path.strip() : __path = os.getenv("HOME")

		self.FileChooser = \
			self.WIDGET_SELF.get_children()[0].get_children()[0].get_children()[0]
		self.FileChooser.set_action(gtk.FILE_CHOOSER_ACTION_OPEN)
		self.FileChooser.set_current_folder(__path)

		self.comboSetChild = self.xml.get_widget("combobox1")

		self.comboSetChild.insert_text(self.CHILD_VIM, _("Open In VIM"))
		self.comboSetChild.set_active(self.CHILD_VIM)
		self.comboSetChild.insert_text(self.CHILD_GVIM, \
			_("Open In GVIM"))

		__checkbox_openInThisPage = self.xml.get_widget("checkbutton1")
		__checkbox_openInThisPage.set_label( \
			_("Open this _file(s) in current tab."))

	def on_open (self, widget) :

		file_selected = list()
		if self.FileChooser.get_select_multiple() :
			file_selected = self.FileChooser.get_filenames()
		else :
			file_selected.append(self.FileChooser.get_filename())

		__b = self.xml.get_widget("checkbutton1")
		openInThisPage = __b.get_active()

		# save the current directory to gconf.
		self.GCONF_CLIENT.set_value( \
			"string",\
			Conf.SCHEMA["last-directory-path-in-fileselectdialog"]["key"], \
			os.path.dirname(file_selected[0]) \
		)

		__func = self.CALLBACK_FUNCTIONS["addPage"]
		for i in file_selected :
			if os.path.isdir(i) : continue

			if not openInThisPage :
				__type_child = self.comboSetChild.get_active()
				if __type_child == self.CHILD_VIM :
					childname = "vim"
				elif __type_child == self.CHILD_GVIM :
					childname = "gvim"
				else :
					pass

				__func(childname, filename=i)
			else :
				__current_page = \
					self.STATE.DATA["notebook"].get_current_page()

				__child_type = \
					self.STATE.DATA["tab-list"][__current_page].Child.CHILD_TYPE

				if __child_type == child.TYPE_GVIM :
					childname = "gvim"
				elif __child_type == child.TYPE_VIM :
					childname = "vim"
				else :
					pass

				__func( \
					childname, filename=i, openInThisPage=openInThisPage)

		self.on_close(True)

class About (WIDGET.WIDGET) :

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

	def on_ok (self, widget) :
		self.on_close(widget)

import GConf, Conf
class Preference (WIDGET.WIDGET) :

	GCONF_CLIENT = None

	FONT_DEFAULT_SYSTEM = str()

	def __init__ (self) :

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		handler = { \
			"on_use_system_font" : self.on_use_system_font, \
			"on_font_set_vim" : self.on_font_set_vim, \
			"on_font_set_terminal" : self.on_font_set_terminal, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			"on_change_vim" : self.on_change_vim, \
			"on_change_gvim" : self.on_change_gvim, \
			"on_change_terminal" : self.on_change_terminal, \
			"on_color_set_fore" : self.on_color_set_fore, \
			"on_color_set_back" : self.on_color_set_back, \
			"on_change_max_scrollline" : self.on_change_max_scrollline, \
		}

		WIDGET.WIDGET.__init__(self, "preferences", None, handler)

		############################################################
		# get widget
		__widget_font_vim = self.xml.get_widget("fontbutton3")
		__widget_font_terminal = self.xml.get_widget("fontbutton4")
		__widget_font_system_default = self.xml.get_widget("checkbutton12")
		__checkbutton_hide_menubar = self.xml.get_widget("checkbutton13")
		__checkbutton_hide_toolbar = self.xml.get_widget("checkbutton14")
		__checkbutton_hide_bookmark = self.xml.get_widget("checkbutton15")
		__widget_command_vim = self.xml.get_widget("entry13")
		__widget_command_gvim = self.xml.get_widget("entry16")
		__widget_command_terminal = self.xml.get_widget("entry14")
		__widget_max_scrollline = self.xml.get_widget("spinbutton1")
		__msg_show_menubar = self.xml.get_widget("label83")
		__label_font_VIM = self.xml.get_widget("label75")
		__label_font_Terminal = self.xml.get_widget("label76")

		__label_tab0 = self.xml.get_widget("label51")
		__label_tab1 = self.xml.get_widget("label59")
		__label_tab2 = self.xml.get_widget("label88")

		__label_tab3 = self.xml.get_widget("label77")
		__label_tab4 = self.xml.get_widget("label78")
		__label_tab5 = self.xml.get_widget("label91")

		__label_tab6 = self.xml.get_widget("label50")
		__label_tab7 = self.xml.get_widget("label58")
		__label_tab8 = self.xml.get_widget("label89")

		# set label
		__checkbutton_hide_menubar.set_label(_("Show menubar"))
		__checkbutton_hide_toolbar.set_label(_("Show toolbar"))
		__checkbutton_hide_bookmark.set_label(_("Show bookmark"))
		__msg_show_menubar.set_label(_("- Ctrl+F11 show the menubar."))
		__widget_font_system_default.set_label( \
			_("Use gnome default terminal font."))
		__label_font_VIM.set_label(_("VIM Font : "))
		__label_font_Terminal.set_label(_("Terminal Font : "))
		__label_tab0.set_label(_("Main"))
		__label_tab1.set_label(_("Command"))
		__label_tab2.set_label(_("Terminal"))
		__label_tab3.set_label(_("VIM Command : "))
		__label_tab4.set_label(_("Terminal Command : "))
		__label_tab5.set_label(_("GVIM Command : "))
		__label_tab6.set_label(_("<b>Main</b>"))
		__label_tab7.set_label(_("<b>Command</b>"))
		__label_tab8.set_label(_("Maximum line number to scroll : "))

		# set default system font.
		self.FONT_DEFAULT_SYSTEM = self.GCONF_CLIENT.get_value( \
				Conf.GLOBAL_FONT_SYSTEM_DEFAULT)

		# set font name
		__fontname_vim = self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-vim"]["key"])
		__fontname_terminal = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-terminal"]["key"])

		if __fontname_vim :
			__widget_font_vim.set_font_name(__fontname_vim)

		if __fontname_terminal :
			__widget_font_terminal.set_font_name(__fontname_terminal)

		__use_system_default_font = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["use-system-default-font"]["key"])

		if __use_system_default_font :
			__widget_font_vim.set_sensitive(False)
			__widget_font_terminal.set_sensitive(False)
			__widget_font_system_default.set_active(True)
		else :
			__widget_font_system_default.set_active(False)

		# show/hide menubar, toolbar, bookmark
		__show_menubar = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"])
		__checkbutton_hide_menubar.set_active(__show_menubar)

		__show_toolbar = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"])
		__checkbutton_hide_toolbar.set_active(__show_toolbar)

		__show_bookmark = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-bookmark"]["key"])
		__checkbutton_hide_bookmark.set_active(__show_bookmark)

		__command_vim = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-vim"]["key"])
		__command_gvim = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-gvim"]["key"])
		__command_terminal = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-terminal"]["key"])

		__widget_command_vim.set_text(__command_vim)
		__widget_command_gvim.set_text(__command_gvim)
		__widget_command_terminal.set_text(__command_terminal)

		# max scrollable line
		__value_max_scrollline = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["max-scrollline"]["key"])

		__widget_max_scrollline.set_value(int(__value_max_scrollline))

	def on_color_set_fore (self, widget) :
		__color = widget.get_color()

		self.GCONF_CLIENT.set_list( \
			"int", Conf.SCHEMA["color-foreground"]["key"], \
			[__color.red, __color.green, __color.blue, __color.pixel])

	def on_color_set_back (self, widget) :
		__color = widget.get_color()

		self.GCONF_CLIENT.set_list( \
			"int", Conf.SCHEMA["color-background"]["key"], \
			[__color.red, __color.green, __color.blue, __color.pixel])

	def on_change_terminal (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-terminal"]["key"], \
			widget.get_text())

	def on_change_vim (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-vim"]["key"], \
			widget.get_text())

	def on_change_gvim (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-gvim"]["key"], \
			widget.get_text())

	def on_toggle_menubar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-menubar"]["key"], __is_activated)

	def on_toggle_toolbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-toolbar"]["key"], __is_activated)

	def on_toggle_bookmark (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-bookmark"]["key"], __is_activated)

	def on_font_set_vim (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["font-vim"]["key"], __font_name)

	def on_font_set_terminal (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["font-terminal"]["key"], __font_name)

	def on_use_system_font (self, widget) :

		__checkbutton = self.xml.get_widget("checkbutton12")

		__buttonFontVIM = self.xml.get_widget("fontbutton3")
		__buttonFontTerminal = self.xml.get_widget("fontbutton4")

		__labelFontVIM = self.xml.get_widget("label75")
		__labelFontTerminal = self.xml.get_widget("label76")

		if __checkbutton.get_active() :

			__buttonFontTerminal.set_sensitive(False)
			__buttonFontVIM.set_sensitive(False)

			__labelFontTerminal.set_sensitive(False)
			__labelFontVIM.set_sensitive(False)

			self.GCONF_CLIENT.set_value( \
				"bool", Conf.SCHEMA["use-system-default-font"]["key"], True)
		else :
			self.GCONF_CLIENT.set_value( \
				"bool", Conf.SCHEMA["use-system-default-font"]["key"], False)

			__buttonFontTerminal.set_sensitive(True)
			__buttonFontVIM.set_sensitive(True)

			__labelFontTerminal.set_sensitive(True)
			__labelFontVIM.set_sensitive(True)

	def on_change_max_scrollline (self, widget) :
		__value = widget.get_value()

		self.GCONF_CLIENT.set_value( \
			"int", Conf.SCHEMA["max-scrollline"]["key"], int(__value))

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Dialog.py"


